import { useCallback, useState } from 'react';
import useRefMounted from './useRefMounted';
var useAsyncFn = function (fn, deps) {
    if (deps === void 0) { deps = []; }
    var _a = useState({
        loading: false,
    }), state = _a[0], set = _a[1];
    var mounted = useRefMounted();
    var callback = useCallback(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        set({ loading: true });
        fn.apply(void 0, args).then(function (value) {
            if (mounted.current) {
                set({ value: value, loading: false });
            }
        }, function (error) {
            if (mounted.current) {
                set({ error: error, loading: false });
            }
        });
    }, deps);
    return [state, callback];
};
export default useAsyncFn;
